Bug 1306681 - (CVE-2013-7447) CVE-2013-7447 gtk2, gtk3: Integer overflow in image handling
CVE-2013-7447 gtk2, gtk3: Integer overflow in image handling
Status: CLOSED WONTFIX
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
low Severity low
: ---
: ---
Assigned To: Red Hat Product Security
impact=low,public=20130627,reported=2...
: Security
Depends On: 1306682 1306683
Blocks: 1306685
  Show dependency treegraph
 
Reported: 2016-02-11 10:04 EST by Adam Mariš
Modified: 2016-03-15 04:24 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-03-14 02:21:57 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Adam Mariš 2016-02-11 10:04:25 EST
An integer overflow vulnerability in gtk+2.0 and gtk+3.0 in image handling was found when supplying large pixbufs to gdk_cairo_set_source_pixbuf, gdkcairo tries to allocate an immense number of bytes.

Upstream patch:

https://git.gnome.org/browse/gtk+/commit?id=894b1ae76a32720f4bb3d39cf460402e3ce331d6

CVE request:

http://seclists.org/oss-sec/2016/q1/302
Comment 1 Adam Mariš 2016-02-11 10:06:42 EST
Created gtk2 tracking bugs for this issue:

Affects: fedora-all [bug 1306682]
Comment 2 Adam Mariš 2016-02-11 10:06:47 EST
Created gtk3 tracking bugs for this issue:

Affects: fedora-all [bug 1306683]
Comment 3 Huzaifa S. Sidhpurwala 2016-03-14 02:08:00 EDT
This is basically a DoS flaw when opening a crafted image. When g_malloc() is asked to malloc huge amount of memory, and it is unable to do it, it crashes with a g_error() amount similar to:

(eog:18754): GLib-ERROR **: /build/buildd/glib2.0-2.36.0/./glib/gmem.c:165: failed to allocate 18446744071914584320 bytes

Also it looks like gtk3 is not affected by this flaw, since the code there is completely different. 

In gdk_cairo_set_source_pixbuf() rather than doing:

cairo_pixels = g_malloc (height * cairo_stride); and creating a "surface" after that by using cairo_image_surface_create_for_data() what gtk3 does is that it uses the cairo function cairo_surface_create_similar_image() to create the surface.

cairo_surface_create_similar_image() uses pixman_image_create() which calculates the size of the buffer needed to hold the image. 

pixman_image_create() handles it correctly by using the following code:

 pixels = FbPixelsCreate (width, height, format->depth);
     if (pixels == NULL)
 	return NULL;

Note You need to log in before you can comment on or make changes to this bug.